<?php
/***************************************************************************

	BEER MOD v.2.2

	Date:			2007-01-05 04:12
	Author: 		qbs (c) 2007
	Website:		http://ixdude.com
	Support:		http://mody.lastinn.info

 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/

define('MODULE_ID', 57909);
define('IN_PHPBB', 1);
define('BEERMOD_CP', 1);

if( !empty($setmodules) )
{
	$file = basename(__FILE__);
	$module['General']['BeerMod'] = $file;
	return;
}

$phpbb_root_path = './../';
require($phpbb_root_path . 'extension.inc');

require('./pagestart.' . $phpEx);
require($phpbb_root_path . "language/lang_" . $board_config['default_lang'] . "/lang_beermod.$phpEx");

if ( !defined('BEER_TABLE') )
{
	message_die(GENERAL_ERROR, 'Modification not installed.');
}

if ( $HTTP_GET_VARS['mode'] == 'check_file_installation' )
{
	redirect( append_sid("admin/admin_beermod_cf.$phpEx") );
}

function convComas($in)
{
	if ( !$in ) return;
	$new_array = array();
	$in_array = explode(',', $in);
	foreach( $in_array as $value )
	{
		$value = intval($value);
		if( $value > 0 )
		{
			$new_array[] = $value;
		}
	}
	return implode(',', $new_array);
}

$old_beer_table_exists = false;
$new_beer_table_exists = false;
$beer_table_compatible = false;
$user_table_compatible = false;

$sql = "SHOW TABLES";
if( !($results = $db->sql_query($sql)) )
{
	message_die(GENERAL_ERROR, 'Couldn\'t obtain mysql tables list.', 'Diagnose interrupted', __LINE__, __FILE__, $sql);
}
while ( $row = $db->sql_fetchrow($results) )
{
	$name = implode('', $row);
	if ( $name == "{$table_prefix}_browery" )
	{
		$old_beer_table_exists = true;
	}
		if ( $name == BEER_TABLE )
	{
		$new_beer_table_exists = true;
	}
}
if ( $new_beer_table_exists )
{
	$sql = "SHOW COLUMNS FROM " . BEER_TABLE;
	if( !($results = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t obtain table details.', 'Diagnose interrupted', __LINE__, __FILE__, $sql);
	}
		
	$compatibility_check_1 = false;
	$compatibility_check_2 = false;
	$compatibility_check_3 = false;
	$compatibility_check_4 = false;
	while ( $row = $db->sql_fetchrow($results) )
	{
		if ( $row['Field'] == 'beer_id' && $row['Key'] == 'PRI' )
		{
			$compatibility_check_1 = true;
		}
		if ( $row['Field'] == 'post_id' && $row['Key'] == 'MUL' )
		{
			$compatibility_check_2 = true;
		}
		if ( $row['Field'] == 'topic_id' && $row['Key'] == 'MUL' )
		{
			$compatibility_check_3 = true;
		}
		if ( $row['Field'] == 'forum_id' && $row['Key'] == 'MUL' )
		{
			$compatibility_check_4 = true;
		}
	}
	if ( $compatibility_check_1 && $compatibility_check_2 && $compatibility_check_3 && $compatibility_check_4 )
	{
		$beer_table_compatible = true;
	}
		
	$sql = "SHOW COLUMNS FROM " . USERS_TABLE;
	if( !($results = $db->sql_query($sql)) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t obtain table details.', 'Diagnose interrupted', __LINE__, __FILE__, $sql);
	}
		
	$compatibility_check_1 = false;
	$compatibility_check_2 = false;
	while ( $row = $db->sql_fetchrow($results) )
	{
		if ( $row['Field'] == 'user_beers_src' )
		{
			$compatibility_check_1 = true;
		}
		if ( $row['Field'] == 'user_beers_dst' )
		{
			$compatibility_check_2 = true;
		}
	}
	if ( $compatibility_check_1 && $compatibility_check_2 )
	{
		$user_table_compatible = true;
	}
}

$perform_repairs = ( $HTTP_GET_VARS['action'] == 'napraw' || !isset( $board_config['beermod_version'] ) ) ? 1 : 0;

if ( $perform_repairs && !$old_beer_table_exists && !$new_beer_table_exists )
{
	$sql = "CREATE TABLE " . BEER_TABLE . " (
		beer_id int(10) unsigned NOT NULL auto_increment,
		beer_src int(10) NOT NULL,
		beer_dst int(10) NOT NULL,
		post_id int(10) NOT NULL,
		topic_id int(12) NOT NULL,
		forum_id int(12) NOT NULL,
		beer_time int(12) NOT NULL,
	PRIMARY KEY  (beer_id),
	KEY post_id (post_id),
	KEY topic_id (topic_id),
	KEY forum_id (forum_id) )";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t perform action.', 'Installation interrupted.', __LINE__, __FILE__, $sql);
	}
	$new_beer_table_exists = true;
	$beer_table_compatible = true;
}
else if ( $perform_repairs && $old_beer_table_exists && !$new_beer_table_exists )
{
	$sql = "RENAME TABLE {$table_prefix}_browery TO " . BEER_TABLE;
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t perform action.', 'Installation interrupted.', __LINE__, __FILE__, $sql);
	}
	$new_beer_table_exists = true;
}
if ( $perform_repairs && $new_beer_table_exists && !$beer_table_compatible )
{
	$db->sql_query("ALTER TABLE " . BEER_TABLE . " DROP INDEX post_id");
	$db->sql_query("ALTER TABLE " . BEER_TABLE . " DROP INDEX topic_id");
	$db->sql_query("ALTER TABLE " . BEER_TABLE . " DROP INDEX forum_id");
	
	$db->sql_query("ALTER TABLE " . BEER_TABLE . " ADD PRIMARY KEY ( beer_id )");
	$db->sql_query("ALTER TABLE " . BEER_TABLE . " DROP INDEX beer_id");
	
	$sql = "ALTER TABLE " . BEER_TABLE . " ADD INDEX ( post_id )";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t perform action.', 'Installation interrupted.', __LINE__, __FILE__, $sql);
	}
	$sql = "ALTER TABLE " . BEER_TABLE . " ADD INDEX ( topic_id )";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t perform action.', 'Installation interrupted.', __LINE__, __FILE__, $sql);
	}
	$sql = "ALTER TABLE " . BEER_TABLE . " ADD INDEX ( forum_id )";
	if( !$db->sql_query($sql) )
	{
		message_die(GENERAL_ERROR, 'Couldn\'t perform action.', 'Installation interrupted.', __LINE__, __FILE__, $sql);
	}
	$beer_table_compatible = true;
}
if ( $perform_repairs && $new_beer_table_exists && !$user_table_compatible )
{
	$db->sql_query("ALTER TABLE " . USERS_TABLE . " ADD user_beers_src MEDIUMINT( 8 ) UNSIGNED NOT NULL DEFAULT '0'");
	$db->sql_query("ALTER TABLE " . USERS_TABLE . " ADD user_beers_dst MEDIUMINT( 8 ) UNSIGNED NOT NULL DEFAULT '0'");
	$user_table_compatible = true;
}

$table_size = 'N/A';
$raw_table_size = 0;
$table_rows = 0;
$result = $db->sql_query("SHOW TABLE STATUS LIKE '" . BEER_TABLE . "'");

while( $row = $db->sql_fetchrow($result) )
{
	$raw_table_size = $row['Data_length'] + $row['Index_length'];
	$table_rows = $row['Rows'];
}

$mega = 1048576;
$kilo = 1024;

$prefix = ( $raw_table_size < $kilo ) ? 1 : (( $raw_table_size < $mega ) ? $kilo : $mega);
$txt_prefix = ( $raw_table_size < $kilo ) ? 'B' : (( $raw_table_size < $mega ) ? 'KB' : 'MB');

$table_size = ($raw_table_size) ? round($raw_table_size / $prefix, 2) . $txt_prefix : $table_size;

$clear_cache = 0;
if ( !isset($board_config['beermod_topic_poster_only']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_topic_poster_only', '0')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_topic_poster_only'] = '0';
}

if ( !isset($board_config['beermod_forums']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_forums', '')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_forums'] = '';
}

if ( !isset($board_config['beermod_sync_delay']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_sync_delay', '24')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_sync_delay'] = '24';
}

if ( !isset($board_config['beermod_post_display_type']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_post_display_type', '1')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_post_display_type'] = '1';
}

if ( !isset($board_config['beermod_version']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_version', '2.1')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_version'] = '2.2';
}
else if ( $board_config['beermod_version'] <> '2.2' )
{
	$sql = "update	" . CONFIG_TABLE . " set config_value = '2.2' where config_name = 'beermod_version'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_version'] = '2.2';
}

if ( !isset($board_config['beermod_last_sync']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_last_sync', '0')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_last_sync'] = '0';
}

if ( !isset($board_config['beermod_enabled']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_enabled', '1')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_enabled'] = '1';
}

if ( !isset($board_config['beermod_show_beers']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_show_beers', '0')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_show_beers'] = '0';
}

if ( !isset($board_config['beermod_unhide_forums']) )
{
	$sql = "insert into	" . CONFIG_TABLE . "
		( config_name, config_value )
		values('beermod_unhide_forums', '')";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	$clear_cache = 1;
	$board_config['beermod_show_beers'] = '0';
}

if ( isset($HTTP_POST_VARS['beermod_topic_poster_only']) && isset($HTTP_POST_VARS['beermod_forums']) && isset($HTTP_POST_VARS['beermod_show_beers']) && isset($HTTP_POST_VARS['beermod_enabled']) )
{
	$beermod_topic_poster_only = intval($HTTP_POST_VARS['beermod_topic_poster_only']);
	$beermod_show_beers = intval($HTTP_POST_VARS['beermod_show_beers']);
	$beermod_sync_delay = intval($HTTP_POST_VARS['beermod_sync_delay']);
	$beermod_post_display_type = intval($HTTP_POST_VARS['beermod_post_display_type']);
	$beermod_enabled = intval($HTTP_POST_VARS['beermod_enabled']);
	$beermod_forums = convComas(( @preg_match('#^(([0-9]|,| )+)$#i', $HTTP_POST_VARS['beermod_forums']) ) ? $HTTP_POST_VARS['beermod_forums'] : '');
	$beermod_unhide_forums = convComas(( @preg_match('#^(([0-9]|,| )+)$#i', $HTTP_POST_VARS['beermod_unhide_forums']) ) ? $HTTP_POST_VARS['beermod_unhide_forums'] : '');


	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_topic_poster_only' where config_name = 'beermod_topic_poster_only'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_show_beers' where config_name = 'beermod_show_beers'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_sync_delay' where config_name = 'beermod_sync_delay'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_enabled' where config_name = 'beermod_enabled'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_forums' where config_name = 'beermod_forums'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_unhide_forums' where config_name = 'beermod_unhide_forums'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}
	
	$sql = "update " . CONFIG_TABLE . " set config_value = '$beermod_post_display_type' where config_name = 'beermod_post_display_type'";
	if(!$result = $db->sql_query($sql))
	{
		message_die(CRITICAL_ERROR, "Could not update forum configuration.", "", __LINE__, __FILE__, $sql);
	}

	$board_config['beermod_unhide_forums'] = $beermod_unhide_forums;
	$board_config['beermod_show_beers'] = $beermod_show_beers;
	$board_config['beermod_sync_delay'] = $beermod_sync_delay;
	$board_config['beermod_enabled'] = $beermod_enabled;
	$board_config['beermod_forums'] = $beermod_forums;
	$board_config['beermod_topic_poster_only'] = $beermod_topic_poster_only;
	$board_config['beermod_post_display_type'] = $beermod_post_display_type;
	$clear_cache = 1;

}

if ( $clear_cache )
{
	sql_cache('clear', 'board_config');
}

$diag_status = ( !$new_beer_table_exists ) ? $lang['Beermod_diag_no_beers_table'] : ( ( !$beer_table_compatible ) ? $lang['Beermod_diag_bad_beers_table'] : ( ( !$user_table_compatible ) ? $lang['Beermod_diag_bad_users_table'] : ( ( $old_beer_table_exists ) ? $lang['Beermod_diag_old_table_exists'] : $lang['Beermod_diag_compatible'] ) ) );



$template->set_filenames(array(
	'body' => 'admin/admin_beermod_body.tpl')
);

$checked = 'checked="checked"';

$template->assign_vars(array(
	'PAGE_TITLE' => $lang['Beermod_title'],
	'L_DB_ROWS' => $lang['Beermod_table_rows'],
	'DB_ROWS' => $table_rows,
	'L_DB_SIZE' => $lang['Beermod_table_size'],
	'DB_SIZE' => $table_size,
	'L_VERSION' => $lang['Beermod_version'],
	'VERSION' => $board_config['beermod_version'],
	'L_LAST_SYNC' => $lang['Beermod_last_sync'],
	'LAST_SYNC' => ( ($board_config['beermod_last_sync']) ? create_date($board_config['default_dateformat'], $board_config['beermod_last_sync'], $board_config['board_timezone']) : $lang['Never']),
	'L_DIAG' => $lang['Beermod_diag'],
	'DIAG' => $diag_status,
	
	'L_CF' => $lang['Beermod_check_file_installation'],
	'CF_URL' => append_sid($phpbb_root_path . "admin/admin_beermod.$phpEx?mode=check_file_installation"),

	'L_INFO' => $lang['Beermod_info'],
	
	'FIX_TABLE' => ( !$new_beer_table_exists || !$beer_table_compatible || !$user_table_compatible ) ? sprintf(' <b>(<a href="%s" class="gensmall">%s</a>)</b>', append_sid("admin_beermod.$phpEx?action=napraw"), $lang['Beermod_fix']) : '-',
	'SYNCHRONIZE' => sprintf('<a href="%s" target="_self">%s</a>', append_sid($phpbb_root_path . "beermod.$phpEx?mode=synchronize"), $lang['Beermod_synchronize']),
	'CHECK_UPDATE' => sprintf($lang['Beermod_check_update'], "http://mody.lastinn.info/t218.html"),

	'L_ENABLED' => $lang['Beermod_enabled'],
	'S_ENABLED_YES' => ( $board_config['beermod_enabled'] ) ? $checked : '',
	'S_ENABLED_NO' => ( !$board_config['beermod_enabled'] ) ? $checked : '',
	
	'L_TOPIC_POSTER_ONLY' => $lang['Beermod_topic_poster_only'],
	'S_TOPIC_POSTER_ONLY_YES' => ( $board_config['beermod_topic_poster_only'] ) ? $checked : '',
	'S_TOPIC_POSTER_ONLY_NO' => ( !$board_config['beermod_topic_poster_only'] ) ? $checked : '',
	
	'L_SHOW_BEERS' => $lang['Beermod_show_beers'],
	'L_SHOW_BEERS_E' => $lang['Beermod_show_beers_e'],
	'S_SHOW_BEERS_YES' => ( $board_config['beermod_show_beers'] ) ? $checked : '',
	'S_SHOW_BEERS_NO' => ( !$board_config['beermod_show_beers'] ) ? $checked : '',

	'L_POST_DISPLAY_TYPE' => $lang['Beermod_post_display_type'],
	'L_POST_DISPLAY_TYPE_E' => $lang['Beermod_post_display_type_e'],
	'L_POST_DISPLAY_TYPE_1' => $lang['Beermod_post_display_type_1'],
	'L_POST_DISPLAY_TYPE_2' => $lang['Beermod_post_display_type_2'],
	'L_POST_DISPLAY_TYPE_3' => $lang['Beermod_post_display_type_3'],
	'L_POST_DISPLAY_TYPE_0' => $lang['Beermod_post_display_type_0'],
	'S_POST_DISPLAY_TYPE_1' => ( $board_config['beermod_post_display_type'] == 1 ) ? $checked : '',
	'S_POST_DISPLAY_TYPE_2' => ( $board_config['beermod_post_display_type'] == 2 ) ? $checked : '',
	'S_POST_DISPLAY_TYPE_3' => ( $board_config['beermod_post_display_type'] == 3 ) ? $checked : '',
	'S_POST_DISPLAY_TYPE_0' => ( !$board_config['beermod_post_display_type'] ) ? $checked : '',

	'L_USE_SYNC' => $lang['Beermod_use_sync'],
	'L_USE_SYNC_E' => $lang['Beermod_use_sync_e'],
	'S_USE_SYNC' => $board_config['beermod_sync_delay'],
	
	'L_FORUMS' => $lang['Beermod_forums'],
	'L_FORUMS_E' => $lang['Beermod_forums_e'],
	'S_FORUMS' => ( preg_match('#(([0-9]|,)+)#i', $board_config['beermod_forums']) ) ? $board_config['beermod_forums'] : '',
	
	'L_UNHIDE_FORUMS' => $lang['Beermod_unhide_forums'],
	'L_UNHIDE_FORUMS_E' => $lang['Beermod_unhide_forums_e'],
	'S_UNHIDE_FORUMS' => ( preg_match('#(([0-9]|,)+)#i', $board_config['beermod_unhide_forums']) ) ? $board_config['beermod_unhide_forums'] : '',
	
	'BEER_FOOTER' => $lang['Beermod_footer'],
));

$template->pparse("body");

include('./page_footer_admin.'.$phpEx);

?>
