<?php
/***************************************************************************

	BEER MOD v.2.2

	Date:			2007-01-04 13:12
	Author: 		qbs (c) 2006
	Website:		http://ixdude.com
	Support:		http://mody.lastinn.info
	
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *
 ***************************************************************************/


if ( !defined('IN_PHPBB') ) 
{
	die('Hacking attempt');
}

class beer
{
	var $posts;
	var $post_users;
	var $user_src;
	var $user_dst;
	var $users;
	var $config;
	var $lang;
	var $topic_first_post_id;
	var $show_sync_errors;
	var $topic_replies;

	function __construct()
	{
		$this->beer();
	}

	function beer()
	{
		global $board_config;
		// asign mod configuration array
		$this->config['enabled'] = $board_config['beermod_enabled'];
		$this->config['forums'] = ( $board_config['beermod_forums'] ) ? explode(',', $board_config['beermod_forums']) : '';
		$this->config['show_post_beers'] = $board_config['beermod_show_beers'];
		$this->config['unhide_bbcode_forums'] = ($board_config['beermod_unhide_forums']) ? $board_config['beermod_unhide_forums'] : '';
		$this->config['sync_delay'] = $board_config['beermod_sync_delay'];
		$this->config['post_display'] = intval($board_config['beermod_post_display_type']);
		$this->config['topic_poster_only'] = intval($board_config['beermod_topic_poster_only']);

		// checking last synchronization
		if ( (time() - $board_config['beermod_last_sync']) > $board_config['beermod_sync_delay'] * 3600 && $board_config['beermod_sync_delay'] )
			$this->synchronize();

		$this->show_sync_errors = 1;
	}

	function synchronize()
	{
		global $db;

		// updating board configuration
		$sql = " 	update	" . CONFIG_TABLE . "
			set	config_value = '" . time() . "'
			where	config_name = 'beermod_last_sync'";

		if ( !$db->sql_query($sql) && $this->show_sync_errors )
		{
			message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $sql);
		}

		// dumping configuration cache
		sql_cache('clear', 'board_config');

		// getting not linked and fake entries
		$trash_beers = array();
		$sql = "	select 	b.beer_id, b.beer_src, b.beer_dst, p.post_id, p.poster_id, t.topic_id, f.forum_id, u1.user_id as user1, u2.user_id as user2
			from	" . BEER_TABLE . " b
			left join 	" . POSTS_TABLE . " p ON p.post_id = b.post_id
			left join 	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
			left join 	" . FORUMS_TABLE . " f ON f.forum_id = b.forum_id
			left join 	" . USERS_TABLE . " u1 ON u1.user_id = b.beer_src
			left join 	" . USERS_TABLE . " u2 ON u2.user_id = b.beer_dst";
		if ( !$db->sql_query($sql) && $this->show_sync_errors )
		{
			message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $sql);
		}
		while ( $row = $db->sql_fetchrow($results) )
		{
			if ( !$row['post_id'] || !$row['topic_id'] || !$row['forum_id'] || !$row['user1'] || !$row['user2'] || $row['beer_src'] == $row['beer_dst'] || $row['beer_src'] == $row['poster_id'] )
				$trash_beers[] = $row['beer_id'];
		}
		// dumping fake entries
		if( count($trash_beers) )
		{
			$sql  = "	delete from " . BEER_TABLE . " where beer_id IN (" . implode(',', $trash_beers) . ")";
			if ( !$db->sql_query($sql) && $this->show_sync_errors )
			{
				message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $sql);
			}
		}

		// synchronizing users beers info

		$updatedata = array();
		$sql = "	SELECT 	b.beer_dst AS user_id, count(b.beer_id) AS user_beers_dst
			FROM	" . BEER_TABLE . " b
			GROUP BY b.beer_dst";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $sql);
		}
		while ( $row = $db->sql_fetchrow($results) )
		{
			$updatedata[$row['user_id']]['user_beers_dst'] = $row['user_beers_dst'];
		}

		$sql = "	SELECT 	b.beer_src AS user_id, count(b.beer_id) AS user_beers_src
			FROM	" . BEER_TABLE . " b
			GROUP BY b.beer_src";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $sql);
		}
		while ( $row = $db->sql_fetchrow($results) )
		{
			$updatedata[$row['user_id']]['user_beers_src'] = $row['user_beers_src'];
		}

		foreach( $updatedata as $user_id => $row )
		{
			$u_sql = "	update 	" . USERS_TABLE . " 
				set 	user_beers_dst = '" . intval($row['user_beers_dst']) . "', 
					user_beers_src = '" . intval($row['user_beers_src']) . "' 
				where 	user_id = '$user_id'";
			if ( !($results = $db->sql_query($u_sql)) )
			{
				message_die(GENERAL_ERROR, 'Synchronization error.', '', __LINE__, __FILE__, $u_sql);
			}
		}
		return true;
	}

	function init($file)
	{
		global $userdata, $board_config, $phpbb_root_path, $phpEx, $db, $template;
		if ( !$this->config['enabled']) return;
		
		$language = ( $userdata['session_logged_in'] ) ? $userdata['user_lang'] : $board_config['default_lang'];
		require($phpbb_root_path . 'language/lang_' .$language . '/lang_beermod.' . $phpEx);
		$this->lang = $lang;

		if ( strpos($file, 'viewtopic') )
		{
			$this->get_beers();
		}
		else if ( strpos($file, 'index') )
		{
			$template->assign_vars(array(
				'BEER_INDEX_URL' => sprintf($lang['Beermod_beermod_index'], append_sid("beermod.$phpEx")),
				));
		}
	}

	function get_beers()
	{
		global $forum_id, $topic_id, $post_id, $userdata, $board_config, $db;

		if ( $this->config['topic_poster_only'] && $topic_id )
		{
			$sql = "	select topic_first_post_id from " . TOPICS_TABLE . " where topic_id = $topic_id";
			if ( !($results = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Couldn\'t obtain topic first post id.', '', __LINE__, __FILE__, $sql);
			}
			$_data = $db->sql_fetchrow($results);
			$this->topic_first_post_id = intval($_data['topic_first_post_id']);
		}

		$user_id = $userdata['user_id'];
		if ( $topic_id > 0 )
		{
			$sql = "	select 	p1.post_id as post_id_sec, b.*, u1.username as beer_poster, u2.user_id, u2.user_beers_src, u2.user_beers_dst, u1.user_level, u1.user_jr, 
					p2.poster_id as poster_id_sec, t.topic_id as topic_id_sec, f.forum_id as forum_id_sec
				from 	" . POSTS_TABLE . " p1
				left join	" . BEER_TABLE . " b ON b.post_id = p1.post_id
				left join 	" . POSTS_TABLE . " p2 ON p2.post_id = b.post_id
				left join 	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
				left join 	" . FORUMS_TABLE . " f ON f.forum_id = b.forum_id
				left join 	" . USERS_TABLE . " u1 ON u1.user_id = b.beer_src
				left join 	" . USERS_TABLE . " u2 ON u2.user_id = p1.poster_id
				where	p1.topic_id = $topic_id " . (($user_id > 1) ? " or b.beer_src = $user_id or b.beer_dst = $user_id" : '');
		}
		else if ( $topic_id < 1 && $post_id > 0 )
		{
			$sql = "	select 	p1.post_id as post_id_sec, b.*, u1.username as beer_poster, u2.user_id, u2.user_beers_src, u2.user_beers_dst, u1.user_level, u1.user_jr, 
					p2.poster_id as poster_id_sec, t.topic_id as topic_id_sec, f.forum_id as forum_id_sec
				from 	" . POSTS_TABLE . " p0
				left join 	" . POSTS_TABLE . " p1 ON p1.topic_id = p0.topic_id
				left join 	" . BEER_TABLE . " b ON (b.post_id = p1.post_id )
				left join 	" . POSTS_TABLE . " p2 ON p2.post_id = b.post_id
				left join 	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
				left join 	" . FORUMS_TABLE . " f ON f.forum_id = b.forum_id
				left join 	" . USERS_TABLE . " u1 ON u1.user_id = b.beer_src
				left join 	" . USERS_TABLE . " u2 ON u2.user_id = p1.poster_id
				where	p0.post_id = $post_id ";
		}
		else
		{
			return false;
		}
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain topic beers', '', __LINE__, __FILE__, $sql);
		}

		$this->topic_replies = $trash_beers = array();
		while ( $row = $db->sql_fetchrow($results) )
		{
			if ( $row['beer_id'] )
			{
				if ( $row['beer_dst'] == $row['beer_src'] || $row['poster_id_sec'] == $row['beer_src'] || !$row['poster_id_sec'] || !$row['forum_id_sec'] || !$row['topic_id_sec'] || !$row['beer_poster'] )
				{
					$trash_beers[] = $row['beer_id'];
				}
				else
				{
					if ( $row['beer_src'] == $user_id && $user_id > 1 ) $this->user_src++;
					if ( $row['beer_dst'] == $user_id && $user_id > 1 ) $this->user_dst++;
					$this->posts[$row['post_id']][] = array( 'user_id' =>$row['beer_src'], 'username' =>$row['beer_poster'], 'user_level' =>$row['user_level'], 'user_jr' =>$row['user_jr'] );
					$this->post_users[$row['post_id']][] = $row['beer_src'];
					if ( @!in_array($row[$row['post_id']]['beer_src'], $this->topic_replies) )
					{
						$this->topic_replies[$row['post_id']][] = $row['beer_src'];
					}
				}
			}
			$this->users[$row['user_id']]['src'] = intval($row['user_beers_src']);
			$this->users[$row['user_id']]['dst'] = intval($row['user_beers_dst']);
		}
		if ( count($trash_beers) )
		{
			$sql = "delete from " . BEER_TABLE . " where beer_id IN (" . implode(',', $trash_beers) . ")";
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Couldn\'t delete fake topic beers', '', __LINE__, __FILE__, $sql);
			}
		}
		$u_sql = array();
		if ( $userdata['user_beers_src'] != $this->user_src )
			$u_sql[] = " user_beers_src = " . intval($this->user_src) . " ";
		if ( $userdata['user_beers_dst'] != $this->user_dst )
			$u_sql[] = " user_beers_dst = " . intval($this->user_dst) . " ";
		if ( count($u_sql) )
		{
			$sql = "update " . USERS_TABLE . " set " . implode(',', $u_sql) . " where user_id = $user_id";
			if ( !$db->sql_query($sql) )
			{
				message_die(GENERAL_ERROR, 'Couldn\'t update user topic beers info', '', __LINE__, __FILE__, $sql);
			}
			$userdata['user_beers_src'] = intval($this->user_src);
			$userdata['user_beers_dst'] = intval($this->user_dst);
		}
	}

	function display_post_beers($postrow_post_id)
	{
		global $template, $post_id, $phpEx;
		
		$lang = $this->lang;
		if ( !count($this->posts[$postrow_post_id]) ) return;
		if ( !$this->config['show_post_beers'] )
		{
			$template->assign_block_vars('postrow.post_beers', array(
				'DETAILS_URL' => append_sid("viewtopic.$phpEx?" . POST_POST_URL . "=$postrow_post_id") . "#$postrow_post_id",
				'L_SHOW_DETAILS' => $lang['Beermod_show_details'],
				));
		}
		else
		{
			$template->assign_block_vars('postrow.post_beers', array(
				'DETAILS_URL' => append_sid("beermod.$phpEx?mode=post_details&amp;" . POST_POST_URL . "=$postrow_post_id"),
				'L_SHOW_DETAILS' => $lang['Beermod_show_more_details'],
				));
		}

		if ( $post_id == $postrow_post_id || $this->config['show_post_beers'] )
		{
			$beer_posters = array();
			foreach ( $this->posts[$postrow_post_id] as $row )
			{
				$colors = color_username($row['user_level'], $row['user_jr'], $row['user_id'], $row['username'], true, 'text-decoration:none');
				$beer_posters[] = '<a href="' . append_sid("profile.$phpEx?mode=viewprofile&amp;" . POST_USERS_URL . "=" . $row['user_id']) . '" class="gensmall" ' . $colors[1] . '>' . $colors[0] . '</a>';
			}
			if ( !$this->config['show_post_beers'] )
			{
				$template->assign_block_vars('postrow.post_beers.beers_details', array(
					'BEER_POSTERS' => implode(', ', $beer_posters),
					'BEERS_SUBMITED' => sprintf($lang['Beermod_beers_posted'], count($beer_posters)),
					'MORE_DETAILS_URL' => append_sid("beermod.$phpEx?mode=post_details&amp;" . POST_POST_URL . "=$postrow_post_id"),
					'L_SHOW_MORE_DETAILS' => $lang['Beermod_show_more_details'],
					));
			}
			else
			{
				$template->assign_block_vars('postrow.post_beers.beers_details', array(
					'BEER_POSTERS' => implode(', ', $beer_posters),
					'BEERS_SUBMITED' => sprintf($lang['Beermod_beers_posted'], count($beer_posters)),
					));
			}
		}
		else
		{
			$template->assign_block_vars('postrow.post_beers.hidden_beers_details', array());
		}
	}

	function display_user_beers($postrow)
	{
		global $template, $phpEx;

		$lang = $this->lang;
		switch ( $this->config['post_display'] )
		{
			case 1:
				if ( $this->users[$postrow['user_id']]['src'] && $this->users[$postrow['user_id']]['dst'] )
				{
					$display = sprintf($lang['Beermod_user_display_1'], append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['dst'], append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['src']);
				}
				else if ( !$this->users[$postrow['user_id']]['src'] && $this->users[$postrow['user_id']]['dst'] )
				{
					$display = sprintf($lang['Beermod_user_display_2'], append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['dst']);
				}
				else if ( $this->users[$postrow['user_id']]['src'] && !$this->users[$postrow['user_id']]['dst'] )
				{
					$display = sprintf($lang['Beermod_user_display_3'], append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['src']);
				}
				else
				{
					return;
				}
				break;
			case 2:
				if ( !$this->users[$postrow['user_id']]['dst'] ) return;
				$display = sprintf($lang['Beermod_user_display_2'], append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['dst']);
				break;
			case 3:
				if ( !$this->users[$postrow['user_id']]['src'] ) return;
				$display = sprintf($lang['Beermod_user_display_3'], append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $postrow['user_id']), $this->users[$postrow['user_id']]['src']);
				break;
			default:
				return;
		}		
		$template->assign_block_vars('postrow.poster_beers', array(
			'POSTER_BEERS' => $display,
			));
	}

	function display_post_icon($postrow)
	{
		global $template, $userdata, $forum_id, $images, $phpEx;

		$lang = $this->lang;
		if ( $postrow['user_id'] == $userdata['user_id'] || $postrow['user_id'] < 2 || @in_array( $userdata['user_id'], $this->post_users[$postrow['post_id']] ) || ( $this->config['forums'] && @!in_array($forum_id, $this->config['forums']) ) || ( $postrow['post_id'] != $this->topic_first_post_id && $this->config['topic_poster_only'] ) ) return;

		$beer_img = '<a href="' . append_sid("beermod.$phpEx?mode=post_beer&amp;" . POST_POST_URL . "=" . $postrow['post_id']) . '"><img src="' . $images['icon_beer'] . '" alt="' . $lang['Beermod_post_beer'] . '" title="' . $lang['Beermod_post_beer'] . '" border="0" /></a>';

		$template->assign_block_vars('postrow.beer_icon', array(
			'BEER_IMG' => $beer_img,
			));
		

	}
	function firstpost($postrow)
	{
		global $template, $userdata, $forum_id, $images, $phpEx;

		$lang = $this->lang;
		if ( $postrow['user_id'] == $userdata['user_id'] || $postrow['user_id'] < 2 || @in_array( $userdata['user_id'], $this->post_users[$postrow['post_id']] ) || ( $this->config['forums'] && @!in_array($forum_id, $this->config['forums']) ) || ( $postrow['post_id'] != $this->topic_first_post_id && $this->config['topic_poster_only'] ) ) return;

		$beer_img = '<a href="' . append_sid("beermod.$phpEx?mode=post_beer&amp;" . POST_POST_URL . "=" . $postrow['post_id']) . '"><img src="' . $images['icon_beer'] . '" alt="' . $lang['Beermod_post_beer'] . '" title="' . $lang['Beermod_post_beer'] . '" border="0" /></a>';

		$template->assign_block_vars('first_post.beer', array(
			'BEER_IMG' => $beer_img,
			));
		

	}
	function viewtopic($postrow)
	{
		$this->display_post_beers($postrow['post_id']);
		$this->display_user_beers($postrow);
		$this->display_post_icon($postrow);
	}
	function viewprofile($userdata)
	{
		global $template, $phpEx;

		$lang = $this->lang;
		$template->assign_block_vars('user_beers', array(
			'L_BEERS' => $lang['Beermod_beers'],
			'BEERS' => sprintf($lang['Beermod_viewprofile'], append_sid("beermod.$phpEx?mode=user_got&amp;" . POST_USERS_URL . "=" . $userdata['user_id']), $userdata['user_beers_dst'], append_sid("beermod.$phpEx?mode=user_gave&amp;" . POST_USERS_URL . "=" . $userdata['user_id']), $userdata['user_beers_src']),
			));
	}
	function submit_beer($db, $post_id, $user_id)
	{
		$time = time();
		$lang = $this->lang;

		// checking is first post beer posting
		if ( $this->config['topic_poster_only'] )
		{
			$sql = "	select	t.topic_first_post_id
				from	" . TOPICS_TABLE . " t, " . POSTS_TABLE . " p
				where	t.topic_id = p.topic_id
				and	p.post_id = $post_id ";
			if ( !($results = $db->sql_query($sql)) )
			{
				message_die(GENERAL_ERROR, 'Couldn\'t obtain topic first post id.', '', __LINE__, __FILE__, $sql);
			}
			$_data = $db->sql_fetchrow($results);
			if ( $_data['topic_first_post_id'] != $post_id )
			{
				message_die(GENERAL_MESSAGE, $lang['Beermod_topic_poster_only']);
			}
		}

		// checking for already posted bears
		$sql = "	select 	beer_id
			from	" . BEER_TABLE . "
			where	beer_src = $user_id
			and	post_id = $post_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain already submitted beers', '', __LINE__, __FILE__, $sql);
		}
		if( $db->sql_numrows($results) )
		{
			message_die(GENERAL_MESSAGE, $lang['Beermod_already_posted']);
		}

		$sql_forums = ($this->config['forums']) ? "and forum_id IN (" . implode(',', $this->config['forums']) . ")" : '';

		// submitting new beer
		$sql = "	insert into " . BEER_TABLE . " ( beer_src, beer_time, beer_dst, post_id, topic_id, forum_id )
				( select 	'$user_id', '$time', poster_id, post_id, topic_id, forum_id
				from	" . POSTS_TABLE . "
			 	where	post_id = $post_id
				$sql_forums
				and	poster_id <> $user_id )";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t post new beer.', '', __LINE__, __FILE__, $sql);
		}
		if ( !($db->sql_affectedrows($results)) )
		{
			message_die(GENERAL_MESSAGE, $lang['Beermod_cannot_post']);
		}

		// updating beer destination user data
		$sql = "select p.poster_id
			from	" . POSTS_TABLE . " p
			where	p.post_id = $post_id
                        limit	1";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain post author.', '', __LINE__, __FILE__, $sql);
		}
		$_data = $db->sql_fetchrow($results);
		$poster_id = $_data['poster_id'];
		
		$sql = "	update 	" . USERS_TABLE . " u set u.user_beers_dst = u.user_beers_dst + 1
				where	u.user_id = $poster_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t update user data (1).', '', __LINE__, __FILE__, $sql);
		}

		// updating beer source user data
		$sql = "	update 	" . USERS_TABLE . " set user_beers_src = user_beers_src + 1
				where	user_id = $user_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t update user data (2).', '', __LINE__, __FILE__, $sql);
		}
		return true;
	}

	function remove_beer($db, $beer_id)
	{
		$sql = "select 	beer_src, beer_dst
			from 	" . BEER_TABLE . "
			where	beer_id = $beer_id
                        limit	1";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain post author.', '', __LINE__, __FILE__, $sql);
		}
		$_data = $db->sql_fetchrow($results);
		$user_id_src = $_data['beer_src'];
		$user_id_dst = $_data['beer_dst'];

		$sql = "	update 	" . USERS_TABLE . " 
			set 	user_beers_src = user_beers_src - 1 
			where 	user_id = $user_id_src";
			
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t update user data (1).', '', __LINE__, __FILE__, $sql);
		}
		$sql = "	update 	" . USERS_TABLE . " 
			set 	user_beers_dst = user_beers_dst - 1 
			where 	user_id = $user_id_dst";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t update user data (2).', '', __LINE__, __FILE__, $sql);
		}
		$sql = "	delete from " . BEER_TABLE . " where beer_id = $beer_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t remove beer.', '', __LINE__, __FILE__, $sql);
		}
		return true;
	}

	function remove_collected_beers($db, $user_id)
	{
		$sql = "	delete from " . BEER_TABLE . " where beer_dst = $user_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t remove beer.', '', __LINE__, __FILE__, $sql);
		}
		$this->synchronize();
		return true;
	}

	function remove_posted_beers($db, $user_id)
	{
		$sql = "	delete from " . BEER_TABLE . " where beer_src = $user_id";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t remove beer.', '', __LINE__, __FILE__, $sql);
		}
		$this->synchronize();
		return true;
	}

	function get_post_beers($post_id)
	{
		global $db;
		$lang = $this->lang;

		$beers = array();
		$sql = "	select	b.beer_id, b.beer_time, b.topic_id, u.user_id, u.username, u.user_level, u.user_jr, u.user_beers_src, u.user_beers_dst, t.topic_title
			from	" . BEER_TABLE . " b
			left join	" . USERS_TABLE . " u ON u.user_id = b.beer_src
			left join	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
			where	b.post_id = $post_id
			order by	u.user_beers_src DESC";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain post beers.', '', __LINE__, __FILE__, $sql);
		}
		$total_src = 0;
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['user_id']] = $row;
			$total_src += $row['user_beers_src'];
		}
		if ( !count($beers) )
			message_die(GENERAL_MESSAGE, $lang['Beermod_no_beers_for_post']);
		$beers['total_src'] = $total_src;
		return $beers;
	}

	function get_topic_beers($topic_id)
	{
		global $db;
		$lang = $this->lang;

		$beers = array();
		$sql = "	select	b.beer_id, b.beer_time, b.post_id, b.topic_id, t.topic_title, count(b.beer_id) as beer_count
			from	" . BEER_TABLE . " b
			left join	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
			where	b.topic_id = $topic_id
			group by	b.post_id
			order by	b.post_id ASC";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain topic beers.', '', __LINE__, __FILE__, $sql);
		}
		$beer_count = 0;
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['post_id']] = $row;
			$beer_count += $row['beer_count'];
		}
		if ( !count($beers) )
			message_die(GENERAL_MESSAGE, $lang['Beermod_no_beers_for_topic']);
		$beers['total_beer_count'] = $beer_count;
		return $beers;
	}

	function get_user_beers($user_id)
	{
		global $db;
		$lang = $this->lang;

		$beers = array();
		$sql = "	select	b.*, count(b.beer_id) as beer_count, t.topic_title
			from	" . BEER_TABLE . " b
			left join	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
			where	b.beer_dst = $user_id
			group by	b.topic_id
			order by	beer_count DESC";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain user beers.', '', __LINE__, __FILE__, $sql);
		}
		$beer_count = 0;
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['topic_id']] = $row;
			$beer_count += $row['beer_count'];
		}
		if ( !count($beers) )
			message_die(GENERAL_MESSAGE, $lang['Beermod_no_beers_collected']);
		$beers['total_beer_count'] = $beer_count;
		return $beers;
	}

	function get_poster_beers($user_id)
	{
		global $db;
		$lang = $this->lang;

		$beers = array();
		$sql = "	select	b.*, count(b.beer_id) as beer_count, t.topic_title
			from	" . BEER_TABLE . " b
			left join	" . TOPICS_TABLE . " t ON t.topic_id = b.topic_id
			where	b.beer_src = $user_id
			group by	b.topic_id
			order by	beer_count DESC";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain poster beers.', '', __LINE__, __FILE__, $sql);
		}
		$beer_count = 0;
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['topic_id']] = $row;
			$beer_count += $row['beer_count'];
		}
		if ( !count($beers) )
			message_die(GENERAL_MESSAGE, $lang['Beermod_no_beers_posted']);
		$beers['total_beer_count'] = $beer_count;
		return $beers;
	}

	function get_user_toplist($user_id)
	{
		global $db;

		$beers = array();
		$sql = "	select	u.user_id, u.username, u.user_level, u.user_jr, u.user_beers_dst, u.user_beers_src
			from	" . USERS_TABLE . " u
			order by	u.user_beers_dst DESC, u.user_regdate ASC
			limit	25";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain user toplist.', '', __LINE__, __FILE__, $sql);
		}
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['user_id']] = $row;
		}
		$sql = "	select sum(user_beers_dst) as total_dst from " . USERS_TABLE;
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain total beers.', '', __LINE__, __FILE__, $sql);
		}
		$beers['total_dst'] = $db->sql_fetchrow($results);
		$beers['total_dst'] = $beers['total_dst']['total_dst'];
		return $beers;
	}

	function get_poster_toplist($user_id)
	{
		global $db;

		$beers = array();
		$sql = "	select	u.user_id, u.username, u.user_level, u.user_jr, u.user_beers_src, u.user_beers_dst
			from	" . USERS_TABLE . " u
			order by	u.user_beers_src DESC, u.user_regdate ASC
			limit	25";
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain poster toplist.', '', __LINE__, __FILE__, $sql);
		}
		while ( $row = $db->sql_fetchrow($results) )
		{
			$beers[$row['user_id']] = $row;
		}
		$sql = "	select sum(user_beers_src) as total_src from " . USERS_TABLE;
		if ( !($results = $db->sql_query($sql)) )
		{
			message_die(GENERAL_ERROR, 'Couldn\'t obtain total beers.', '', __LINE__, __FILE__, $sql);
		}
		$beers['total_src'] = $db->sql_fetchrow($results);
		$beers['total_src'] = $beers['total_src']['total_src'];
		return $beers;
	}
}
$beermod = new beer();

?>
